#include "../burnint.h"
// System 16 - Misc

// This function loads code roms. All even roms should be first, followed by all odd roms.
int BsysLoadCode(unsigned char *Rom,int Start,int Count)
{
  int i=0,Odd=0; int nRet=0;
  Count>>=1; // Half the count, then load all even then all odd

  for (Odd=0;Odd<2;Odd++)
  {
    unsigned char *pLoad; pLoad=Rom+(Odd^1); // ^1 for byteswapped

    for (i=0;i<Count;i++)
    {
      struct BurnRomInfo ri;
      // Load these even/odd bytes
      nRet=BurnLoadRom(pLoad,Start+i,2); if (nRet!=0) return 1;

      // Increment position by the length of the rom * 2
      ri.nLen=0; BurnDrvGetRomInfo(&ri,Start+i); pLoad+=ri.nLen<<1;
    }
    Start+=Count; // Move on to the odd byte roms
  }

  return 0;
}

// Load 3 roms as bitplanes of tile data
int BsysLoadTiles(unsigned char *Tile,int Start)
{
  struct BurnRomInfo ri; unsigned char *TileTmp=NULL;
  int i=0; int nRetVal=0;
  ri.nLen=0; BurnDrvGetRomInfo(&ri,Start); // Find out how big the tile roms are

  // Load tile data (three bitfields)
  TileTmp=(unsigned char *)malloc(ri.nLen); if (TileTmp==NULL) return 1;
  memset(TileTmp,0,ri.nLen);
  for (i=0;i<3;i++)
  {
    int nRet;  nRet=BurnLoadRom(TileTmp,Start+i,1);  if (nRet!=0) nRetVal=1;
    BurnLoadBitField(Tile,TileTmp,i,ri.nLen);
  }
  free(TileTmp); TileTmp=NULL;

  return nRetVal;
}

// Change color 15 to 0, to eliminate the System16 (guide?)lines
int BsysZeroSprites(unsigned char *Spr,int Len)
{
  unsigned char *ps,*pEnd;
  if (Len<=0) return 1;
  pEnd=Spr+Len;
  ps=Spr;

  do
  {
    unsigned char x;
    x=(unsigned char)(~ps[0]);
    if ((x&0xf0)==0) ps[0]&=0x0f;
    if ((x&0x0f)==0) ps[0]&=0xf0;
    ps++;
  }
  while (ps<pEnd);

  return 0;
}
