// Burner Game Control
#include "app.h"

static char szPlay[4][4]={"p1 ","p2 ","p3 ","p4 "};

#define KEY(x) { pgi->nInput=2; pgi->nCode=(unsigned short)(x); }

// Configure the misc game controls
int GamcMisc(struct GameInp *pgi,char *szi)
{
  // Digital controls
  if (strcmp(szi,"diag"    )==0) KEY(DIK_F2)
  if (strcmp(szi,"reset"   )==0) KEY(DIK_F3)
  if (strcmp(szi,"p1 start")==0) KEY(DIK_1)
  if (strcmp(szi,"p2 start")==0) KEY(DIK_2)
  if (strcmp(szi,"p3 start")==0) KEY(DIK_3)
  if (strcmp(szi,"p4 start")==0) KEY(DIK_4)
  if (strcmp(szi,"p1 coin" )==0) KEY(DIK_5)
  if (strcmp(szi,"p2 coin" )==0) KEY(DIK_6)
  if (strcmp(szi,"p3 coin" )==0) KEY(DIK_7)
  if (strcmp(szi,"p4 coin" )==0) KEY(DIK_8)
  if (strcmp(szi,"service" )==0) KEY(DIK_9)

  // Dip switches - set to a constant and get the value from the driver
  if (strcmp(szi,"dip")==0) { pgi->nInput=1; pgi->nConst=*(pgi->pVal); }
  return 0;
}

int GamcAnalogKey(struct GameInp *pgi,char *szi,int nPlayer,int nSlide)
{
  char *szSearch=NULL; int k0=0,k1=0;
  szSearch=szPlay[nPlayer&3];
  if (strncmp(szSearch,szi,3)!=0) return 1; // Not our player
  szi+=3;

  if (*szi == 0) return 1;
  if (strcmp(szi+1,"-axis")!=0) return 1;

  // Keyboard
  if (szi[0]=='x') { k0=DIK_LEFT; k1=DIK_RIGHT; }
  if (szi[0]=='y') { k0=DIK_UP; k1=DIK_DOWN; }
  if (szi[0]=='z') { k0=DIK_F; k1=DIK_V; }
  if (k0==0) return 1;

  pgi->nInput=4;
  pgi->nSlider[0]=(unsigned char)k0;
  pgi->nSlider[1]=(unsigned char)k1;

  pgi->nSliderValue=0x8000; // Put slider in the middle
  if (nSlide==2)
  {
    // Sliding
    pgi->nSliderSpeed=0x700; pgi->nSliderCenter=0;
  }
  else
  {
    // Sliding (centering)
    pgi->nSliderSpeed=0xe00; pgi->nSliderCenter=10;
  }

  return 0;
}

int GamcAnalogJoy(struct GameInp *pgi,char *szi,int nPlayer,int nJoy,int nSlide)
{
  char *szSearch=NULL;
  szSearch=szPlay[nPlayer&3];
  if (strncmp(szSearch,szi,3)!=0) return 1; // Not our player
  szi+=3;

  if (szi[0]==0) return 1;
  if (strcmp(szi+1,"-axis")!=0) return 1;

  pgi->nJoy=(unsigned char)nJoy;
  // Joystick
  if (strcmp(szi,"x-axis")==0) { pgi->nAxis=0; }
  if (strcmp(szi,"y-axis")==0) { pgi->nAxis=1; }
  if (strcmp(szi,"z-axis")==0) { pgi->nAxis=2; }

  pgi->nSliderValue=0x8000; // Put slider in the middle
  if (nSlide==2)
  {
    // Sliding
    pgi->nInput=5; pgi->nSliderSpeed=0x700; pgi->nSliderCenter=0;
  }
  else if (nSlide==1)
  {
    // Sliding (centering)
    pgi->nInput=5; pgi->nSliderSpeed=0xe00; pgi->nSliderCenter=10;
  }
  else
  {
    // Absolute
    pgi->nInput=3; 
  }

  return 0;
}

// Set a Game Input to use Device 'nDevice' if it belongs to 'nPlayer'
// -2 = nothing  -1 == keyboard, 0 == joystick 1, 1 == joystick 2 etc...
int GamcPlayer(struct GameInp *pgi,char *szi,int nPlayer,int nDevice)
{
  char *szSearch=NULL; int nJoyBase=0;
  szSearch=szPlay[nPlayer&3];
  if (strncmp(szSearch,szi,3)!=0) return 1; // Not our player
  szi+=3;

  if (nDevice<=-2)
  {
    int bOurs=0;
    if (strcmp(szi,"up"   )==0) bOurs=1;
    if (strcmp(szi,"down" )==0) bOurs=1;
    if (strcmp(szi,"left" )==0) bOurs=1;
    if (strcmp(szi,"right")==0) bOurs=1;
    if (strncmp(szi,"fire ",5)==0) bOurs=1;

    if (!bOurs) return 1;
    pgi->nInput=1; pgi->nConst=0; // Constant zero
    return 0;
  }
  // Now check the rest of it
  if (nDevice==-1)
  {
    // Keyboard
    if (strcmp(szi,"up"   )==0)  KEY(DIK_UPARROW)
    if (strcmp(szi,"down" )==0)  KEY(DIK_DOWNARROW)
    if (strcmp(szi,"left" )==0)  KEY(DIK_LEFTARROW)
    if (strcmp(szi,"right")==0)  KEY(DIK_RIGHTARROW)
    if (strcmp(szi,"fire 1")==0) KEY(DIK_Z)
    if (strcmp(szi,"fire 2")==0) KEY(DIK_X)
    if (strcmp(szi,"fire 3")==0) KEY(DIK_C)
    if (strcmp(szi,"fire 4")==0) KEY(DIK_A)
    if (strcmp(szi,"fire 5")==0) KEY(DIK_S)
    if (strcmp(szi,"fire 6")==0) KEY(DIK_D)
    return 0;
  }

  // Joystick
  nJoyBase =0x4000;
  nJoyBase|=nDevice<<8;

  if (strcmp(szi,"up"   )==0) KEY(nJoyBase+0x01)
  if (strcmp(szi,"down" )==0) KEY(nJoyBase+0x02)
  if (strcmp(szi,"left" )==0) KEY(nJoyBase+0x03)
  if (strcmp(szi,"right")==0) KEY(nJoyBase+0x04)
  if (strncmp(szi,"fire ",5)==0)
  {
    char *szb=szi+5; int nButton;
    nButton=strtol(szb,NULL,0);
    if (nButton>=1) nButton--;
    KEY(nJoyBase+0x10+nButton)
  }
  return 0;
}

int GamcPlayerHotRod(struct GameInp *pgi,char *szi,int nPlayer,int nSide)
{
  char *szSearch=NULL;
  szSearch=szPlay[nPlayer&3];
  if (strncmp(szSearch,szi,3)!=0) return 1; // Not our player
  szi+=3;

  if (nSide==0)
  {
    // Hanaho HotRod joystick left side
    if (strcmp(szi,"up"   )==0)  KEY(DIK_NUMPAD8)
    if (strcmp(szi,"down" )==0)  KEY(DIK_NUMPAD2)
    if (strcmp(szi,"left" )==0)  KEY(DIK_NUMPAD4)
    if (strcmp(szi,"right")==0)  KEY(DIK_NUMPAD6)
    if (strcmp(szi,"fire 1")==0) KEY(DIK_LSHIFT)
    if (strcmp(szi,"fire 2")==0) KEY(DIK_Z)
    if (strcmp(szi,"fire 3")==0) KEY(DIK_X)
    if (strcmp(szi,"fire 4")==0) KEY(DIK_LCONTROL)
    if (strcmp(szi,"fire 5")==0) KEY(DIK_LALT)
    if (strcmp(szi,"fire 6")==0) KEY(DIK_SPACE)
    if (strcmp(szi,"start" )==0) KEY(DIK_1)
    if (strcmp(szi,"coin"  )==0) KEY(DIK_3)
    return 0;
  }
  else if (nSide==1)
  {
    // Hanaho HotRod joystick right side
    if (strcmp(szi,"up"   )==0)  KEY(DIK_R)
    if (strcmp(szi,"down" )==0)  KEY(DIK_F)
    if (strcmp(szi,"left" )==0)  KEY(DIK_D)
    if (strcmp(szi,"right")==0)  KEY(DIK_G)
    if (strcmp(szi,"fire 1")==0) KEY(DIK_W)
    if (strcmp(szi,"fire 2")==0) KEY(DIK_E)
    if (strcmp(szi,"fire 3")==0) KEY(DIK_LBRACKET)
    if (strcmp(szi,"fire 4")==0) KEY(DIK_A)
    if (strcmp(szi,"fire 5")==0) KEY(DIK_S)
    if (strcmp(szi,"fire 6")==0) KEY(DIK_Q)
    if (strcmp(szi,"start" )==0) KEY(DIK_2)
    if (strcmp(szi,"coin"  )==0) KEY(DIK_4)
    return 0;
  }

  return 1; // unknown side
}

#undef KEY


